diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/internet/model/global-router-interface.cc ns-3.40/src/internet/model/global-router-interface.cc
--- ns-3.39/src/internet/model/global-router-interface.cc	2023-07-05 14:23:47.845427500 -0700
+++ ns-3.40/src/internet/model/global-router-interface.cc	2023-09-27 13:30:37.654839000 -0700
@@ -193,12 +193,10 @@
 GlobalRoutingLSA::CopyLinkRecords(const GlobalRoutingLSA& lsa)
 {
     NS_LOG_FUNCTION(this << &lsa);
-    for (ListOfLinkRecords_t::const_iterator i = lsa.m_linkRecords.begin();
-         i != lsa.m_linkRecords.end();
-         i++)
+    for (auto i = lsa.m_linkRecords.begin(); i != lsa.m_linkRecords.end(); i++)
     {
         GlobalRoutingLinkRecord* pSrc = *i;
-        GlobalRoutingLinkRecord* pDst = new GlobalRoutingLinkRecord;
+        auto pDst = new GlobalRoutingLinkRecord;
 
         pDst->SetLinkType(pSrc->GetLinkType());
         pDst->SetLinkId(pSrc->GetLinkId());
@@ -222,7 +220,7 @@
 GlobalRoutingLSA::ClearLinkRecords()
 {
     NS_LOG_FUNCTION(this);
-    for (ListOfLinkRecords_t::iterator i = m_linkRecords.begin(); i != m_linkRecords.end(); i++)
+    for (auto i = m_linkRecords.begin(); i != m_linkRecords.end(); i++)
     {
         NS_LOG_LOGIC("Free link record");
 
@@ -256,8 +254,7 @@
 {
     NS_LOG_FUNCTION(this << n);
     uint32_t j = 0;
-    for (ListOfLinkRecords_t::const_iterator i = m_linkRecords.begin(); i != m_linkRecords.end();
-         i++, j++)
+    for (auto i = m_linkRecords.begin(); i != m_linkRecords.end(); i++, j++)
     {
         if (j == n)
         {
@@ -358,9 +355,7 @@
 {
     NS_LOG_FUNCTION(this << n);
     uint32_t j = 0;
-    for (ListOfAttachedRouters_t::const_iterator i = m_attachedRouters.begin();
-         i != m_attachedRouters.end();
-         i++, j++)
+    for (auto i = m_attachedRouters.begin(); i != m_attachedRouters.end(); i++, j++)
     {
         if (j == n)
         {
@@ -422,9 +417,7 @@
 
     if (m_lsType == GlobalRoutingLSA::RouterLSA)
     {
-        for (ListOfLinkRecords_t::const_iterator i = m_linkRecords.begin();
-             i != m_linkRecords.end();
-             i++)
+        for (auto i = m_linkRecords.begin(); i != m_linkRecords.end(); i++)
         {
             GlobalRoutingLinkRecord* p = *i;
 
@@ -469,9 +462,7 @@
     {
         os << "---------- NetworkLSA Link Record ----------" << std::endl;
         os << "m_networkLSANetworkMask = " << m_networkLSANetworkMask << std::endl;
-        for (ListOfAttachedRouters_t::const_iterator i = m_attachedRouters.begin();
-             i != m_attachedRouters.end();
-             i++)
+        for (auto i = m_attachedRouters.begin(); i != m_attachedRouters.end(); i++)
         {
             Ipv4Address p = *i;
             os << "attachedRouter = " << p << std::endl;
@@ -545,7 +536,7 @@
 {
     NS_LOG_FUNCTION(this);
     m_routingProtocol = nullptr;
-    for (InjectedRoutesI k = m_injectedRoutes.begin(); k != m_injectedRoutes.end();
+    for (auto k = m_injectedRoutes.begin(); k != m_injectedRoutes.end();
          k = m_injectedRoutes.erase(k))
     {
         delete (*k);
@@ -557,7 +548,7 @@
 GlobalRouter::ClearLSAs()
 {
     NS_LOG_FUNCTION(this);
-    for (ListOfLSAs_t::iterator i = m_LSAs.begin(); i != m_LSAs.end(); i++)
+    for (auto i = m_LSAs.begin(); i != m_LSAs.end(); i++)
     {
         NS_LOG_LOGIC("Free LSA");
 
@@ -614,7 +605,7 @@
     //
     // Every router node originates a Router-LSA
     //
-    GlobalRoutingLSA* pLSA = new GlobalRoutingLSA;
+    auto pLSA = new GlobalRoutingLSA;
     pLSA->SetLSType(GlobalRoutingLSA::RouterLSA);
     pLSA->SetLinkStateId(m_routerId);
     pLSA->SetAdvertisingRouter(m_routerId);
@@ -717,9 +708,9 @@
     // Build injected route LSAs as external routes
     // RFC 2328, section 12.4.4
     //
-    for (InjectedRoutesCI i = m_injectedRoutes.begin(); i != m_injectedRoutes.end(); i++)
+    for (auto i = m_injectedRoutes.begin(); i != m_injectedRoutes.end(); i++)
     {
-        GlobalRoutingLSA* pLSA = new GlobalRoutingLSA;
+        auto pLSA = new GlobalRoutingLSA;
         pLSA->SetLSType(GlobalRoutingLSA::ASExternalLSAs);
         pLSA->SetLinkStateId((*i)->GetDestNetwork());
         pLSA->SetAdvertisingRouter(m_routerId);
@@ -752,7 +743,7 @@
 {
     NS_LOG_FUNCTION(this << nd << pLSA << &c);
 
-    GlobalRoutingLinkRecord* plr = new GlobalRoutingLinkRecord;
+    auto plr = new GlobalRoutingLinkRecord;
     NS_ABORT_MSG_IF(plr == nullptr,
                     "GlobalRouter::ProcessSingleBroadcastLink(): Can't alloc link record");
 
@@ -1193,7 +1184,7 @@
         Ipv4Address addrLocal = ipv4Local->GetAddress(interfaceLocal, 0).GetLocal();
         Ipv4Mask maskLocal = ipv4Local->GetAddress(interfaceLocal, 0).GetMask();
 
-        GlobalRoutingLSA* pLSA = new GlobalRoutingLSA;
+        auto pLSA = new GlobalRoutingLSA;
         NS_ABORT_MSG_IF(pLSA == nullptr,
                         "GlobalRouter::BuildNetworkLSAs(): Can't alloc link record");
 
@@ -1604,7 +1595,7 @@
     // walk the list of link state advertisements created there and return the
     // one the client is interested in.
     //
-    ListOfLSAs_t::const_iterator i = m_LSAs.begin();
+    auto i = m_LSAs.begin();
     uint32_t j = 0;
 
     for (; i != m_LSAs.end(); i++, j++)
@@ -1624,7 +1615,7 @@
 GlobalRouter::InjectRoute(Ipv4Address network, Ipv4Mask networkMask)
 {
     NS_LOG_FUNCTION(this << network << networkMask);
-    Ipv4RoutingTableEntry* route = new Ipv4RoutingTableEntry();
+    auto route = new Ipv4RoutingTableEntry();
     //
     // Interface number does not matter here, using 1.
     //
@@ -1639,7 +1630,7 @@
     if (index < m_injectedRoutes.size())
     {
         uint32_t tmp = 0;
-        for (InjectedRoutesCI i = m_injectedRoutes.begin(); i != m_injectedRoutes.end(); i++)
+        for (auto i = m_injectedRoutes.begin(); i != m_injectedRoutes.end(); i++)
         {
             if (tmp == index)
             {
@@ -1666,7 +1657,7 @@
     NS_LOG_FUNCTION(this << index);
     NS_ASSERT(index < m_injectedRoutes.size());
     uint32_t tmp = 0;
-    for (InjectedRoutesI i = m_injectedRoutes.begin(); i != m_injectedRoutes.end(); i++)
+    for (auto i = m_injectedRoutes.begin(); i != m_injectedRoutes.end(); i++)
     {
         if (tmp == index)
         {
@@ -1683,7 +1674,7 @@
 GlobalRouter::WithdrawRoute(Ipv4Address network, Ipv4Mask networkMask)
 {
     NS_LOG_FUNCTION(this << network << networkMask);
-    for (InjectedRoutesI i = m_injectedRoutes.begin(); i != m_injectedRoutes.end(); i++)
+    for (auto i = m_injectedRoutes.begin(); i != m_injectedRoutes.end(); i++)
     {
         if ((*i)->GetDestNetwork() == network && (*i)->GetDestNetworkMask() == networkMask)
         {
@@ -1791,8 +1782,7 @@
 bool
 GlobalRouter::BridgeHasAlreadyBeenVisited(Ptr<BridgeNetDevice> bridgeNetDevice) const
 {
-    std::vector<Ptr<BridgeNetDevice>>::iterator iter;
-    for (iter = m_bridgesVisited.begin(); iter != m_bridgesVisited.end(); ++iter)
+    for (auto iter = m_bridgesVisited.begin(); iter != m_bridgesVisited.end(); ++iter)
     {
         if (bridgeNetDevice == *iter)
         {
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/internet/model/global-router-interface.h ns-3.40/src/internet/model/global-router-interface.h
--- ns-3.39/src/internet/model/global-router-interface.h	2023-07-05 14:23:47.845427500 -0700
+++ ns-3.40/src/internet/model/global-router-interface.h	2023-09-27 13:30:37.654839000 -0700
@@ -21,11 +21,12 @@
 #ifndef GLOBAL_ROUTER_INTERFACE_H
 #define GLOBAL_ROUTER_INTERFACE_H
 
+#include "global-route-manager.h"
+#include "ipv4-routing-table-entry.h"
+
 #include "ns3/bridge-net-device.h"
 #include "ns3/channel.h"
-#include "ns3/global-route-manager.h"
 #include "ns3/ipv4-address.h"
-#include "ns3/ipv4-routing-table-entry.h"
 #include "ns3/net-device-container.h"
 #include "ns3/node.h"
 #include "ns3/object.h"
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/internet/model/icmpv4.h ns-3.40/src/internet/model/icmpv4.h
--- ns-3.39/src/internet/model/icmpv4.h	2023-07-05 14:23:47.845427500 -0700
+++ ns-3.40/src/internet/model/icmpv4.h	2023-09-27 13:30:37.654839000 -0700
@@ -20,8 +20,9 @@
 #ifndef ICMPV4_H
 #define ICMPV4_H
 
+#include "ipv4-header.h"
+
 #include "ns3/header.h"
-#include "ns3/ipv4-header.h"
 #include "ns3/ptr.h"
 
 #include <stdint.h>
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/internet/model/icmpv6-header.cc ns-3.40/src/internet/model/icmpv6-header.cc
--- ns-3.39/src/internet/model/icmpv6-header.cc	2023-07-05 14:23:47.845427500 -0700
+++ ns-3.40/src/internet/model/icmpv6-header.cc	2023-09-27 13:30:37.654839000 -0700
@@ -346,9 +346,9 @@
     SetType(ICMPV6_ND_NEIGHBOR_ADVERTISEMENT);
     SetCode(0);
     SetReserved(0);
-    SetFlagR(0);
-    SetFlagS(0);
-    SetFlagO(0);
+    SetFlagR(false);
+    SetFlagS(false);
+    SetFlagO(false);
     m_checksum = 0;
 }
 
@@ -545,9 +545,9 @@
     NS_LOG_FUNCTION(this);
     SetType(ICMPV6_ND_ROUTER_ADVERTISEMENT);
     SetCode(0);
-    SetFlagM(0);
-    SetFlagO(0);
-    SetFlagH(0);
+    SetFlagM(false);
+    SetFlagO(false);
+    SetFlagH(false);
     SetCurHopLimit(0);
     SetLifeTime(0);
     SetRetransmissionTime(0);
@@ -1192,7 +1192,7 @@
     iter.WriteU32(0);
 
     uint32_t size = m_packet->GetSize();
-    uint8_t* buf = new uint8_t[size];
+    auto buf = new uint8_t[size];
     m_packet->CopyData(buf, size);
     iter.Write(buf, size);
     delete[] buf;
@@ -1308,7 +1308,7 @@
     iter.WriteHtonU32(GetMtu());
 
     uint32_t size = m_packet->GetSize();
-    uint8_t* buf = new uint8_t[size];
+    auto buf = new uint8_t[size];
     m_packet->CopyData(buf, size);
     iter.Write(buf, size);
     delete[] buf;
@@ -1410,7 +1410,7 @@
     iter.WriteU32(0);
 
     uint32_t size = m_packet->GetSize();
-    uint8_t* buf = new uint8_t[size];
+    auto buf = new uint8_t[size];
     m_packet->CopyData(buf, size);
     iter.Write(buf, size);
     delete[] buf;
@@ -1527,7 +1527,7 @@
     iter.WriteHtonU32(GetPtr());
 
     uint32_t size = m_packet->GetSize();
-    uint8_t* buf = new uint8_t[size];
+    auto buf = new uint8_t[size];
     m_packet->CopyData(buf, size);
     iter.Write(buf, size);
     delete[] buf;
@@ -2128,7 +2128,7 @@
     i.WriteU32(0);
 
     uint32_t size = m_packet->GetSize();
-    uint8_t* buf = new uint8_t[size];
+    auto buf = new uint8_t[size];
     m_packet->CopyData(buf, size);
     i.Write(buf, size);
     delete[] buf;
@@ -2147,7 +2147,7 @@
     i.ReadU32();
 
     uint32_t len2 = (GetLength() - 1) * 8;
-    uint8_t* buff = new uint8_t[len2];
+    auto buff = new uint8_t[len2];
     i.Read(buff, len2);
     m_packet = Create<Packet>(buff, len2);
     delete[] buff;
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/internet/model/icmpv6-l4-protocol.cc ns-3.40/src/internet/model/icmpv6-l4-protocol.cc
--- ns-3.39/src/internet/model/icmpv6-l4-protocol.cc	2023-07-05 14:23:47.845427500 -0700
+++ ns-3.40/src/internet/model/icmpv6-l4-protocol.cc	2023-09-27 13:30:37.654839000 -0700
@@ -168,7 +168,7 @@
 Icmpv6L4Protocol::DoDispose()
 {
     NS_LOG_FUNCTION(this);
-    for (CacheList::const_iterator it = m_cacheList.begin(); it != m_cacheList.end(); it++)
+    for (auto it = m_cacheList.begin(); it != m_cacheList.end(); it++)
     {
         Ptr<NdiscCache> cache = *it;
         cache->Dispose();
@@ -397,7 +397,7 @@
 {
     NS_LOG_FUNCTION(this << packet << src << dst << interface);
     Icmpv6Echo request;
-    uint8_t* buf = new uint8_t[packet->GetSize()];
+    auto buf = new uint8_t[packet->GetSize()];
 
     packet->RemoveHeader(request);
     /* XXX IPv6 extension: obtain a fresh copy of data otherwise it crash... */
@@ -522,9 +522,7 @@
             waiting = entry->MarkReachable(lla.GetAddress());
             entry->StartReachableTimer();
             // send out waiting packet
-            for (std::list<NdiscCache::Ipv6PayloadHeaderPair>::const_iterator it = waiting.begin();
-                 it != waiting.end();
-                 it++)
+            for (auto it = waiting.begin(); it != waiting.end(); it++)
             {
                 cache->GetInterface()->Send(it->first, it->second, src);
             }
@@ -558,10 +556,7 @@
             {
                 entry->StopNudTimer();
                 waiting = entry->MarkReachable(lla.GetAddress());
-                for (std::list<NdiscCache::Ipv6PayloadHeaderPair>::const_iterator it =
-                         waiting.begin();
-                     it != waiting.end();
-                     it++)
+                for (auto it = waiting.begin(); it != waiting.end(); it++)
                 {
                     cache->GetInterface()->Send(it->first, it->second, src);
                 }
@@ -605,7 +600,7 @@
     Icmpv6RS rsHeader;
     packet->RemoveHeader(rsHeader);
     Address hardwareAddress;
-    Icmpv6OptionLinkLayerAddress lla(1);
+    Icmpv6OptionLinkLayerAddress lla(true);
     NdiscCache::Entry* entry = nullptr;
     Ptr<NdiscCache> cache = FindCache(interface->GetDevice());
 
@@ -786,7 +781,7 @@
     if (!src.IsAny())
     {
         Icmpv6OptionLinkLayerAddress llOption(
-            1,
+            true,
             hardwareAddress); /* we give our mac address in response */
         p->AddHeader(llOption);
     }
@@ -813,7 +808,7 @@
     NS_LOG_FUNCTION(this << src << dst << id << seq << data);
     Ptr<Packet> p = data->Copy();
     Ipv6Header ipHeader;
-    Icmpv6Echo req(1);
+    Icmpv6Echo req(true);
 
     req.SetId(id);
     req.SetSeq(seq);
@@ -841,7 +836,7 @@
 {
     NS_LOG_FUNCTION(this << packet << src << dst << interface);
     Icmpv6NA naHeader;
-    Icmpv6OptionLinkLayerAddress lla(1);
+    Icmpv6OptionLinkLayerAddress lla(true);
 
     packet->RemoveHeader(naHeader);
     Ipv6Address target = naHeader.GetIpv6Target();
@@ -911,9 +906,7 @@
             waiting = entry->MarkReachable(lla.GetAddress());
             entry->StartReachableTimer();
             /* send out waiting packet */
-            for (std::list<NdiscCache::Ipv6PayloadHeaderPair>::const_iterator it = waiting.begin();
-                 it != waiting.end();
-                 it++)
+            for (auto it = waiting.begin(); it != waiting.end(); it++)
             {
                 cache->GetInterface()->Send(it->first, it->second, src);
             }
@@ -978,10 +971,7 @@
             if (naHeader.GetFlagS())
             {
                 waiting = entry->MarkReachable(lla.GetAddress());
-                for (std::list<NdiscCache::Ipv6PayloadHeaderPair>::const_iterator it =
-                         waiting.begin();
-                     it != waiting.end();
-                     it++)
+                for (auto it = waiting.begin(); it != waiting.end(); it++)
                 {
                     cache->GetInterface()->Send(it->first, it->second, src);
                 }
@@ -1022,7 +1012,7 @@
     NS_LOG_FUNCTION(this << packet << src << dst << interface);
     bool hasLla = false;
     Ptr<Packet> p = packet->Copy();
-    Icmpv6OptionLinkLayerAddress llOptionHeader(0);
+    Icmpv6OptionLinkLayerAddress llOptionHeader(false);
 
     Icmpv6Redirection redirectionHeader;
     p->RemoveHeader(redirectionHeader);
@@ -1255,7 +1245,7 @@
     NS_LOG_FUNCTION(this << src << dst << hardwareAddress << static_cast<uint32_t>(flags));
     Ptr<Packet> p = Create<Packet>();
     Icmpv6NA na;
-    Icmpv6OptionLinkLayerAddress llOption(0, *hardwareAddress); /* not a source link layer */
+    Icmpv6OptionLinkLayerAddress llOption(false, *hardwareAddress); /* not a source link layer */
 
     NS_LOG_LOGIC("Send NA ( from " << src << " to " << dst << " target " << src << ")");
     na.SetIpv6Target(src);
@@ -1289,7 +1279,7 @@
 {
     NS_LOG_FUNCTION(this << src << dst << id << seq << data);
     Ptr<Packet> p = data->Copy();
-    Icmpv6Echo reply(0); /* echo reply */
+    Icmpv6Echo reply(false); /* echo reply */
 
     reply.SetId(id);
     reply.SetSeq(seq);
@@ -1313,7 +1303,7 @@
     /* Ipv6Header ipHeader; */
     Icmpv6NS ns(target);
     Icmpv6OptionLinkLayerAddress llOption(
-        1,
+        true,
         hardwareAddress); /* we give our mac address in response */
 
     /* if the source is unspec, multicast the NA to all-nodes multicast */
@@ -1356,10 +1346,21 @@
     // unspecified address. Otherwise, it SHOULD be included on link layers that have addresses.
     if (!src.IsAny())
     {
-        Icmpv6OptionLinkLayerAddress llOption(1, hardwareAddress);
+        Icmpv6OptionLinkLayerAddress llOption(true, hardwareAddress);
         p->AddHeader(llOption);
     }
 
+    if (!src.IsAny())
+    {
+        Ptr<Ipv6L3Protocol> ipv6 = m_node->GetObject<Ipv6L3Protocol>();
+        if (ipv6->GetInterfaceForAddress(src) == -1)
+        {
+            NS_LOG_INFO("Preventing RS from being sent or rescheduled because the source address "
+                        << src << " has been removed");
+            return;
+        }
+    }
+
     NS_LOG_LOGIC("Send RS (from " << src << " to " << dst << ")");
 
     rs.CalculatePseudoHeaderChecksum(src, dst, p->GetSize() + rs.GetSerializedSize(), PROT_NUMBER);
@@ -1548,7 +1549,7 @@
     uint32_t llaSize = 0;
     Ptr<Packet> p = Create<Packet>();
     uint32_t redirectedPacketSize = redirectedPacket->GetSize();
-    Icmpv6OptionLinkLayerAddress llOption(0);
+    Icmpv6OptionLinkLayerAddress llOption(false);
 
     NS_LOG_LOGIC("Send Redirection ( to " << dst << " target " << redirTarget << " destination "
                                           << redirDestination << " )");
@@ -1606,7 +1607,7 @@
     Ipv6Header ipHeader;
     Icmpv6NA na;
     Icmpv6OptionLinkLayerAddress llOption(
-        0,
+        false,
         *hardwareAddress); /* we give our mac address in response */
 
     NS_LOG_LOGIC("Send NA ( from " << src << " to " << dst << ")");
@@ -1653,7 +1654,7 @@
     Ipv6Header ipHeader;
     Icmpv6NS ns(target);
     Icmpv6OptionLinkLayerAddress llOption(
-        1,
+        true,
         hardwareAddress); /* we give our mac address in response */
 
     NS_LOG_LOGIC("Send NS ( from " << src << " to " << dst << " target " << target << ")");
@@ -1676,7 +1677,7 @@
 {
     NS_LOG_FUNCTION(this << device);
 
-    for (CacheList::const_iterator i = m_cacheList.begin(); i != m_cacheList.end(); i++)
+    for (auto i = m_cacheList.begin(); i != m_cacheList.end(); i++)
     {
         if ((*i)->GetDevice() == device)
         {
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/internet/model/ipv4-address-generator.cc ns-3.40/src/internet/model/ipv4-address-generator.cc
--- ns-3.39/src/internet/model/ipv4-address-generator.cc	2023-07-05 14:23:47.845427500 -0700
+++ ns-3.40/src/internet/model/ipv4-address-generator.cc	2023-09-27 13:30:37.654839000 -0700
@@ -342,8 +342,8 @@
     NS_ABORT_MSG_UNLESS(m_netTable[index].addr <= m_netTable[index].addrMax,
                         "Ipv4AddressGeneratorImpl::NextAddress(): Address overflow");
 
-    Ipv4Address addr = Ipv4Address((m_netTable[index].network << m_netTable[index].shift) |
-                                   m_netTable[index].addr);
+    Ipv4Address addr((m_netTable[index].network << m_netTable[index].shift) |
+                     m_netTable[index].addr);
 
     ++m_netTable[index].addr;
     //
@@ -404,7 +404,7 @@
         //
         if (addr == (*i).addrHigh + 1)
         {
-            std::list<Entry>::iterator j = i;
+            auto j = i;
             ++j;
 
             if (j != m_entries.end())
@@ -459,9 +459,7 @@
         addr,
         "Ipv4AddressGeneratorImpl::IsAddressAllocated(): Don't check for the broadcast address...");
 
-    std::list<Entry>::iterator i;
-
-    for (i = m_entries.begin(); i != m_entries.end(); ++i)
+    for (auto i = m_entries.begin(); i != m_entries.end(); ++i)
     {
         NS_LOG_LOGIC("examine entry: " << Ipv4Address((*i).addrLow) << " to "
                                        << Ipv4Address((*i).addrHigh));
@@ -469,10 +467,10 @@
         {
             NS_LOG_LOGIC("Ipv4AddressGeneratorImpl::IsAddressAllocated(): Address Collision: "
                          << Ipv4Address(addr));
-            return false;
+            return true;
         }
     }
-    return true;
+    return false;
 }
 
 bool
@@ -485,14 +483,12 @@
         "Ipv4AddressGeneratorImpl::IsNetworkAllocated(): network address and mask don't match "
             << address << " " << mask);
 
-    std::list<Entry>::iterator i;
-
-    for (i = m_entries.begin(); i != m_entries.end(); ++i)
+    for (auto i = m_entries.begin(); i != m_entries.end(); ++i)
     {
         NS_LOG_LOGIC("examine entry: " << Ipv4Address((*i).addrLow) << " to "
                                        << Ipv4Address((*i).addrHigh));
-        Ipv4Address low = Ipv4Address((*i).addrLow);
-        Ipv4Address high = Ipv4Address((*i).addrHigh);
+        Ipv4Address low((*i).addrLow);
+        Ipv4Address high((*i).addrHigh);
 
         if (address == low.CombineMask(mask) || address == high.CombineMask(mask))
         {
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/internet/model/ipv4-end-point-demux.cc ns-3.40/src/internet/model/ipv4-end-point-demux.cc
--- ns-3.39/src/internet/model/ipv4-end-point-demux.cc	2023-07-05 14:23:47.845427500 -0700
+++ ns-3.40/src/internet/model/ipv4-end-point-demux.cc	2023-09-27 13:30:37.654839000 -0700
@@ -40,7 +40,7 @@
 Ipv4EndPointDemux::~Ipv4EndPointDemux()
 {
     NS_LOG_FUNCTION(this);
-    for (EndPointsI i = m_endPoints.begin(); i != m_endPoints.end(); i++)
+    for (auto i = m_endPoints.begin(); i != m_endPoints.end(); i++)
     {
         Ipv4EndPoint* endPoint = *i;
         delete endPoint;
@@ -52,7 +52,7 @@
 Ipv4EndPointDemux::LookupPortLocal(uint16_t port)
 {
     NS_LOG_FUNCTION(this << port);
-    for (EndPointsI i = m_endPoints.begin(); i != m_endPoints.end(); i++)
+    for (auto i = m_endPoints.begin(); i != m_endPoints.end(); i++)
     {
         if ((*i)->GetLocalPort() == port)
         {
@@ -66,7 +66,7 @@
 Ipv4EndPointDemux::LookupLocal(Ptr<NetDevice> boundNetDevice, Ipv4Address addr, uint16_t port)
 {
     NS_LOG_FUNCTION(this << addr << port);
-    for (EndPointsI i = m_endPoints.begin(); i != m_endPoints.end(); i++)
+    for (auto i = m_endPoints.begin(); i != m_endPoints.end(); i++)
     {
         if ((*i)->GetLocalPort() == port && (*i)->GetLocalAddress() == addr &&
             (*i)->GetBoundNetDevice() == boundNetDevice)
@@ -87,7 +87,7 @@
         NS_LOG_WARN("Ephemeral port allocation failed.");
         return nullptr;
     }
-    Ipv4EndPoint* endPoint = new Ipv4EndPoint(Ipv4Address::GetAny(), port);
+    auto endPoint = new Ipv4EndPoint(Ipv4Address::GetAny(), port);
     m_endPoints.push_back(endPoint);
     NS_LOG_DEBUG("Now have >>" << m_endPoints.size() << "<< endpoints.");
     return endPoint;
@@ -103,7 +103,7 @@
         NS_LOG_WARN("Ephemeral port allocation failed.");
         return nullptr;
     }
-    Ipv4EndPoint* endPoint = new Ipv4EndPoint(address, port);
+    auto endPoint = new Ipv4EndPoint(address, port);
     m_endPoints.push_back(endPoint);
     NS_LOG_DEBUG("Now have >>" << m_endPoints.size() << "<< endpoints.");
     return endPoint;
@@ -126,7 +126,7 @@
         NS_LOG_WARN("Duplicated endpoint.");
         return nullptr;
     }
-    Ipv4EndPoint* endPoint = new Ipv4EndPoint(address, port);
+    auto endPoint = new Ipv4EndPoint(address, port);
     m_endPoints.push_back(endPoint);
     NS_LOG_DEBUG("Now have >>" << m_endPoints.size() << "<< endpoints.");
     return endPoint;
@@ -140,7 +140,7 @@
                             uint16_t peerPort)
 {
     NS_LOG_FUNCTION(this << localAddress << localPort << peerAddress << peerPort << boundNetDevice);
-    for (EndPointsI i = m_endPoints.begin(); i != m_endPoints.end(); i++)
+    for (auto i = m_endPoints.begin(); i != m_endPoints.end(); i++)
     {
         if ((*i)->GetLocalPort() == localPort && (*i)->GetLocalAddress() == localAddress &&
             (*i)->GetPeerPort() == peerPort && (*i)->GetPeerAddress() == peerAddress &&
@@ -150,7 +150,7 @@
             return nullptr;
         }
     }
-    Ipv4EndPoint* endPoint = new Ipv4EndPoint(localAddress, localPort);
+    auto endPoint = new Ipv4EndPoint(localAddress, localPort);
     endPoint->SetPeer(peerAddress, peerPort);
     m_endPoints.push_back(endPoint);
 
@@ -163,7 +163,7 @@
 Ipv4EndPointDemux::DeAllocate(Ipv4EndPoint* endPoint)
 {
     NS_LOG_FUNCTION(this << endPoint);
-    for (EndPointsI i = m_endPoints.begin(); i != m_endPoints.end(); i++)
+    for (auto i = m_endPoints.begin(); i != m_endPoints.end(); i++)
     {
         if (*i == endPoint)
         {
@@ -183,7 +183,7 @@
     NS_LOG_FUNCTION(this);
     EndPoints ret;
 
-    for (EndPointsI i = m_endPoints.begin(); i != m_endPoints.end(); i++)
+    for (auto i = m_endPoints.begin(); i != m_endPoints.end(); i++)
     {
         Ipv4EndPoint* endP = *i;
         ret.push_back(endP);
@@ -211,7 +211,7 @@
     EndPoints retval4; // Exact match on all 4
 
     NS_LOG_DEBUG("Looking up endpoint for destination address " << daddr << ":" << dport);
-    for (EndPointsI i = m_endPoints.begin(); i != m_endPoints.end(); i++)
+    for (auto i = m_endPoints.begin(); i != m_endPoints.end(); i++)
     {
         Ipv4EndPoint* endP = *i;
 
@@ -376,7 +376,7 @@
     // function.
     uint32_t genericity = 3;
     Ipv4EndPoint* generic = nullptr;
-    for (EndPointsI i = m_endPoints.begin(); i != m_endPoints.end(); i++)
+    for (auto i = m_endPoints.begin(); i != m_endPoints.end(); i++)
     {
         if ((*i)->GetLocalPort() != dport)
         {
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/internet/model/ipv4-end-point.h ns-3.40/src/internet/model/ipv4-end-point.h
--- ns-3.39/src/internet/model/ipv4-end-point.h	2023-07-05 14:23:47.845427500 -0700
+++ ns-3.40/src/internet/model/ipv4-end-point.h	2023-09-27 13:30:37.654839000 -0700
@@ -20,10 +20,11 @@
 #ifndef IPV4_END_POINT_H
 #define IPV4_END_POINT_H
 
+#include "ipv4-header.h"
+#include "ipv4-interface.h"
+
 #include "ns3/callback.h"
 #include "ns3/ipv4-address.h"
-#include "ns3/ipv4-header.h"
-#include "ns3/ipv4-interface.h"
 #include "ns3/net-device.h"
 
 #include <stdint.h>
